#include<stdio.h>
#include<math.h>
#include<ctype.h>
#include<string.h>
#include<stdlib.h>
#include<iostream>
using namespace std;
main()
{
	long int t;
	int o[t];
	cin>>t;
	for(int i=0;i<t;i++)
	{
		int a,b;
		cin>>a;
		cin>>b;
		float x[a];
		
		//unosi prihvacene zalbe
		for(int j=0;j<a;j++)
		{
			cin>>x[j];
		}
		
		//sortira
		for(int j=0;j<a;j++)
		{
			for(int k=j+1;k<=a;k++)
			{
				if(x[j]>x[k])
				{
					float temp=x[j];
					x[j]=x[k];
					x[k]=temp;
				}
			}
		}
		//unosi ne prihvacene zalbe
		for(int j=0;j<b;j++)
		{
			float temp;
			cin>>temp;
		}
		//da li
		if(a==2)
		{
			o[i]=1;
			goto Prvi;
		}
		for(int j=0;j<a-1;j++)
		{
			float temp = x[j+1]-x[j];
			if(o[i]==0)goto Prvi;
			if(x[j]+temp==x[j+1] || x[j]+temp/2==x[j+1] || x[j]+temp/3==x[j+1] || x[j]+temp*2==x[j+1] || x[j]+temp*3==x[j+1])
			{
				
			}
			else
			{
				o[i]=0;
			}
		}
		o[i]=1;
		Prvi:;
	}
	for(int i=0;i<t;i++)cout<<o[i]<<endl;
}